"""
    Nomad Broker

    Make payments, and customs declaration for orders.  # noqa: E501

    The version of the OpenAPI document: 1.2.1
    Contact: manwei@samarkand.global
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from nomad_broker_cli.api_client import ApiClient, Endpoint
from nomad_broker_cli.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from nomad_broker_cli.model.api_response import ApiResponse
from nomad_broker_cli.model.declare_order_youzan_req_body import DeclareOrderYouzanReqBody
from nomad_broker_cli.model.declare_order_youzan_res200 import DeclareOrderYouzanRes200
from nomad_broker_cli.model.error_api_response import ErrorApiResponse
from nomad_broker_cli.model.query_order_youzan_req_body import QueryOrderYouzanReqBody
from nomad_broker_cli.model.query_order_youzan_res200 import QueryOrderYouzanRes200


class YouzanApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __declare_order_youzan_post(
            self,
            **kwargs
        ):
            """declare_order_youzan_post  # noqa: E501

            Declare an order after successful payment on youzan platform  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.declare_order_youzan_post(async_req=True)
            >>> result = thread.get()


            Keyword Args:
                x_youzan_token (str): [optional]
                declare_order_youzan_req_body (DeclareOrderYouzanReqBody): [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                DeclareOrderYouzanRes200
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            return self.call_with_http_info(**kwargs)

        self.declare_order_youzan_post = Endpoint(
            settings={
                'response_type': (DeclareOrderYouzanRes200,),
                'auth': [
                    'authorization'
                ],
                'endpoint_path': '/declare-order/youzan',
                'operation_id': 'declare_order_youzan_post',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_youzan_token',
                    'declare_order_youzan_req_body',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_youzan_token':
                        (str,),
                    'declare_order_youzan_req_body':
                        (DeclareOrderYouzanReqBody,),
                },
                'attribute_map': {
                    'x_youzan_token': 'X-Youzan-Token',
                },
                'location_map': {
                    'x_youzan_token': 'header',
                    'declare_order_youzan_req_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__declare_order_youzan_post
        )

        def __query_order_youzan_post(
            self,
            **kwargs
        ):
            """query_order_youzan_post  # noqa: E501

            Query an order after the customs declaration  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.query_order_youzan_post(async_req=True)
            >>> result = thread.get()


            Keyword Args:
                x_youzan_token (str): [optional]
                query_order_youzan_req_body (QueryOrderYouzanReqBody): [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                QueryOrderYouzanRes200
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            return self.call_with_http_info(**kwargs)

        self.query_order_youzan_post = Endpoint(
            settings={
                'response_type': (QueryOrderYouzanRes200,),
                'auth': [
                    'authorization'
                ],
                'endpoint_path': '/query-order/youzan',
                'operation_id': 'query_order_youzan_post',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'x_youzan_token',
                    'query_order_youzan_req_body',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'x_youzan_token':
                        (str,),
                    'query_order_youzan_req_body':
                        (QueryOrderYouzanReqBody,),
                },
                'attribute_map': {
                    'x_youzan_token': 'X-Youzan-Token',
                },
                'location_map': {
                    'x_youzan_token': 'header',
                    'query_order_youzan_req_body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__query_order_youzan_post
        )
